#include <stdio.h>
#include "StackGraph.h"

void StackGraph::clear() {
  while(head != NULL) {
    StackGraphItem *aux = head;
    head = head->getNext();
    delete aux;
  }

  tail = NULL;
  length = 0;
}

void StackGraph::push(bool *pGraph, int pEdges, int pLength) {
  StackGraphItem *newItem = new StackGraphItem(pGraph, pEdges, pLength, head);
  if(head == NULL) tail = newItem;
  head = newItem;
  length++;
}

void StackGraph::push(StackGraphItem *item) {
  if(item != NULL) {
    item->setNext(head);
    if(head == NULL) tail = item;
    head = item;
    length++;
  }
}

StackGraphItem *StackGraph::pop() {
  if(!empty()) {
    StackGraphItem *aux = head;
    head = head->getNext();
    if(head == NULL) tail = NULL;
    length--;

    return aux;
  }
  else return NULL;
}

StackGraph *StackGraph::getBottom() {
  StackGraph *res = new StackGraph();

  if(length > 1) {
    int bottomEdges = tail->getEdges();
    StackGraphItem *aux = head;
    StackGraphItem *last = NULL;
    int i = 0;
    
    while(aux != NULL) {
      if(((i % 2) == 0) && (last != NULL) && (aux->getEdges() == bottomEdges)) {
        last->setNext(aux->getNext());
        length--;
        res->push(aux);
        i++;
	aux = last->getNext();
      }
      else {
	if(aux->getEdges() == bottomEdges) i++;
        last = aux;
        aux = aux->getNext();
      }
    }
  }
  
  return res;
}

